
;
;**************************************************************************
;*                     DH servis - David Hankovec	                  *
;**************************************************************************
;*                                PIC16F874/877                           *
;*                               --------\/--------                       *
;*                         +5V  -|MCLR     PGD/RB7|-          	          *
;*              		-|RA0/AN0  PGC/RB6|-       		  *
;*               		-|RA1/AN1      RB5|-                      *
;*     				-|RA2/AN2      RB4|-                      *
;*   	      	  		-|RA3/AN3  PGM/RB3|-         	          *
;*       			-|RA4          RB2|-    		  *
;*                 		-|RA5/AN4      RB1|-         		  *
;*                   		-|RE0/RD   INT/RB0|-        		  *
;*            			-|RE1/WR       Vdd|-  +5V                 *
;*           			-|RE2/CS       Vss|-   0V                 *
;*                     	  +5V 	-|Vdd          RD7|-   			  *
;*                          0V 	-|Vss          RD6|-     		  *
;*          Krystal 4,00 Mhz / 	-|osc1         RD5|-    		  *
;*                           \ 	-|osc2         RD4|-    		  *
;*     				-|RC0       Rx/RC7|-  IN  / RS232         *
;*     				-|RC1       Tx/RC6|-  OUT / RS232         *
;*      			-|RC2          RC5|-    		  *
;*      		  	-|RC3/SCL  SDA/RC4|-  SDA  		  *
;*      			-|RD0          RD3|-   	 	 	  *
;*				-|RD1          RD2|-   			  *
;*                               ------------------                       *
;*                                              DH servis (c) 2002-2004   *
;**************************************************************************


;testy registrovych paru - protoze vsechny registry jsou 16 bitove a skladaji se tim padem z 2x8
;pokud zasleme adresu napr. GP0 a zapiseme data, pak dalsim zapisem dat zapisujeme automaticky do GP1 



	list p=16F877A, R=DEC
	include "P16F877A.inc"

TMP0		equ	2CH	;docasna
TMP1		equ	2DH
TMP2		equ	2EH
TMP3		equ	2FH
flags		equ	30H
I2C_chyba	equ	0			;priznak chyby pri odesilani IIC

;-----------------------------------IIC commands----------------------------------
#define	GP0	0x00			;MCP230 REGISTR 0=
#define	GP1	0x01			;REGISTR 1
#define	OLAT0	0x02		;OUTPUT LATCH REGISTERS
#define	OLAT1	0x03		;
#define	IODIR0	0x06		;SETTING OUT or IN PINS (jako TRIS u PIC) 1=IN 0=OUT
#define	IODIR1	0x07		;	----""--------
#define	INTCAP0	0x08		;REGISTR ZACHYCENEHO STAVU GP0 PRI PRERUSENI
#define	INTCAP1	0x09		;REGISTR ZACHYCENEHO STAVU GP1 PRI PRERUSENI
#define	IOCON0	0x0A		;INTERRUPT ACTIVITY RESOLUTION (pouze nejnizsi bit) 0=scan 32 msec. 1=scan 200usec.
#define	IOCON1	0x0B		;	----""--------
;-------------------------------------------------
;Adresy expanderu pro zapis
	constant	one_write=b'01000000'	;zapis do obvodu s adresou 000 (A0,A1,A2)
	constant	two_write=b'01000010'	;zapis do obvodu s adresou 001	
;------------------------------------------------------------------------
;Adresy expanderu pro cteni
	constant	one_read=b'01000001'	;cteni z obvodu s adresou 000
	constant	two_read=b'01000011'	;cteni z obvodu s adresou 001


	
 	__config _BODEN_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC & _DEBUG_OFF & _CPD_OFF & _LVP_OFF

	org	0x0000		; zacatek programu
	goto	INIT		; skok na pocatecni inicializaci

;**************************************************************************
INIT	
	bcf	STATUS,RP0	; nastaveni BANKY 0
	bcf	STATUS,RP1	; nastaveni BANKY 0
;	------------------------
	movlw	b'00000000'	; prednastaveni PORTu A
	movwf	PORTA
	movlw	b'00000000'	; prednastaveni PORTu B
	movwf	PORTB
	movlw	b'11111111'	; prednastaveni PORTu C
	movwf	PORTC
	movlw	b'00000000'	; prednastaveni PORTu D
	movwf	PORTD		;
	movlw	b'00000000'	; prednastaveni PORTu E
	movwf	PORTE		;
;       ------------------------
	bsf	STATUS,RP0	; nastaveni BANKY 1


;------------------NASTAVENI PORTU A--------------------------------------------
	movlw	b'00000111'			;3sloupce out, zbytek IN
	movwf	TRISA						
;-------------------------------------------------------------------------------
		
;------------------NASTAVENI PORTU B--------------------------------------------
	movlw	b'00001111'	; PULL-UPy ON, preddelic=1:128 pripojen k watchdog
	movwf	OPTION_REG	; 
	movlw	b'11110000'	; portB 7-0, 4vstupy, 4vystupy
	movwf	TRISB
;-------------------------------------------------------------------------------

;------------------NASTAVENI PORTU D--------------------------------------------
	movlw	b'11110011'	
	movwf	TRISD						
;-------------------------------------------------------------------------------


;------------------NASTAVENI PORTU E--------------------------------------------
	movlw	b'000'		; nejnizsi jako vstup - ovladani alarmu
	movwf	TRISE
	bcf		TRISE,PSPMODE
	bcf		ADCON1,PCFG0
	bsf		ADCON1,PCFG1
	bsf		ADCON1,PCFG2
	bcf		ADCON1,PCFG3
;BACHA konfigurace ADCON1 ma vliv na komparatory !!!!!!!!!!!!!!!!!!!!!!!!
;-------------------------------------------------------------------------------

;---------------------------------------------------------------------------
;KOMPARATORY (stale v bance 1):
;al comparators off
	bsf	CMCON,CM0
	bsf	CMCON,CM1
	bsf	CMCON,CM2	;konfigurace vstupu nastavena
;-----------------------------------------------------------------------------
	bcf STATUS,RP0          ; RAM PAGE 0
;-----------------------------------------------------------------------------------
; inicializace pro I2C
;-----------------------------------------------------------------------------------
;-----------------------------------------------  vstupy/vstupy
	BSF		STATUS,RP0
	BCF		STATUS,RP1		; vbr banky 1
	MOVLW		b'10011000'		; SDA a SCL musi bt nastaveny jako vstupy
	MOVWF		TRISC
	BCF		STATUS,RP0

;-----------------------------------------------  I2C
	MOVLW		b'00101000'		; nastaveni registru SSPCON
	MOVWF		SSPCON
	BSF		STATUS,RP0		; banka 1
	MOVLW		b'10000000'		; nastaveni registru SSPSTAT
	MOVWF		SSPSTAT
	MOVLW		10				; (Fosc / (4 * prenosova rychlost)) - 1
	MOVWF		SSPADD
	BCF		STATUS,RP0		; banka 0
;--------------------------------------------------------------------------------------
	bcf	INTCON,PEIE	; 1=povolena vsechna periferni preruseni
	bcf	INTCON,GIE
	bcf	INTCON,RBIE
	call	SET_232
	goto	MAIN
;-------------------------------------------------------------------

;**************************************************************************
MAIN
;povolte si rutinu dle pozadavku
	goto	blikani		;test zapisu do MCP23016
;goto	read_pin
;goto	read_int	;test cteni pod prerusenim
	goto	$	
;-----------------------------------------------------------------------------------------------------------
;---------------------------TESTY EXPANDERU----------------------------------------------------------------------
;-------------------------------------------------------------							
;		I N I C I A L I Z A C E      M C P 2 3 0 1 6			  					
;-------------------------------------------------------------	

				
;********************************TESTOVANI CTENI POD PRERUSENIM******************************************
read_int
;cteni dvou byte (GP0 a GP1) je oddelene, takze cteni jednoho registru nenuluje preruseni od druheho registru	
;nastaveni cteni z GP0
;POZOR, PIN 6 MCP23016 je open collector, musi byt pullup na +
	call	CEK100m			;NUTNO POCKAT min. 72ms PRO INICIALIZACI MCP23016, zde cekame 100msec. 			
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;----------------------Nastaveni registru expanderu-----------------------------------
	movlw	IODIR0			;nastaveni in/out									
	call	I2C_odesli		;vyslani dat
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016											

	movlw	b'11111111'		;data do registru (vsechny piny registru 0 vstup)					
	call	I2C_odesli		;odeslani dat												
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	
;zapis registroveho paru - zapisuje do IODIR1	
	movlw	b'00000000'		;data do registru (vsechny piny registru 1vstup - pro testy jej nepotrebujeme)
	call	I2C_odesli		;vyslani dat		
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	;zkontroluj, zda priso potvrzeni o primu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	call	I2C_stop		;I2C_STOP
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;---nastaveni ukonceno----------------	
testuj_preruseni
	btfsc	PORTC,2				;preruseni je vyvolano na pinu 6 MCP23016 po kazde zmene na portu
	goto	testuj_preruseni	;rychlost samplovani zmen se provadi zapisem do registru IOCON0 a IOCON1
								;zde nepouzito = implicitne 32 msec.
	btfss	PORTC,0				;hodnota je zachycena  prechodem INT do L, nutno cist az pri prechodu do H
	goto	$-1
;---------------------------------------
;preruseni dokonceno, precteme obsah CAPTURE registru - pro testy pouze port GP0 (resp. 

	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
;budeme cist GP0 - cili zapiseme do adresovaneho MCP23016 slave
	movlw	INTCAP0			;budeme posilat data do vystupniho registru
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_restart		;restart periferie
	call	CEK40			;40 usec.
;-------------------------------------------------------------------------------------------
	movlw	one_read		;adresa - prvni obvod, a budeme cist (zmena nejnizsiho bitu na 1 - cteni)
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_prijmi
	call	I2C_odesli_ack	;odesli potvrzeni o prijmu dat
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_stop		;I2C_STOP
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------	
	
;----Nacteme prijatou hodnotu a odesleme seriovou linkou, odesila se pouze pri zmene na portu SLAVE	
	movf	SSPBUF,W			;nacti hodnotu
	call	send
	goto	testuj_preruseni
;--------------------------------------------------------
;********************************KONEC******************************************



;********************************TESTOVANI CTENI Z PINU******************************************
read_pin
	call	CEK100m			;NUTNO POCKAT min. 72ms PRO INICIALIZACI MCP23016, zde cekame 100msec. 			
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;----------------------Nastaveni registru expanderu-----------------------------------
	movlw	IODIR0			;nastaveni in/out									
	call	I2C_odesli		;vyslani dat
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016											

	movlw	b'11111111'		;data do registru (vsechny piny registru 0 vstup)					
	call	I2C_odesli		;odeslani dat												
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	
;zapis registroveho paru - zapisuje do IODIR1	
	movlw	b'00000000'		;data do registru (vsechny piny registru 1vstup - pro testy jej nepotrebujeme)
	call	I2C_odesli		;vyslani dat		
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	;zkontroluj, zda priso potvrzeni o primu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	call	I2C_stop		;I2C_STOP
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;---nastaveni ukonceno----------------	
reading
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
;budeme cist GP0 - cili zapiseme do adresovaneho MCP23016 slave
	movlw	GP0				;budeme posilat data do vystupniho registru
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_restart		;restart periferie
	call	CEK40			;40 usec.
;-------------------------------------------------------------------------------------------
	movlw	one_read		;adresa - prvni obvod, a budeme cist (zmena nejnizsiho bitu na 1 - cteni)
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_prijmi
	call	I2C_odesli_ack	;odesli potvrzeni o prijmu dat
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------
	call	I2C_stop		;I2C_STOP
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;-------------------------------------------------------------------------------------------	
	
;----Nacteme prijatou hodnotu a odesleme seriovou linkou, pockame 1 sekundu a opakujeme cteni	
	movf	SSPBUF,W			;nacti hodnotu
	call	send
	call	CEK1s				;cekame  sekundu
	goto	reading
;--------------------------------------------------------
;********************************KONEC******************************************



;********************************TESTOVANI ZAPISU******************************************
blikani
	call	CEK100m			;NUTNO POCKAT min. 72ms PRO INICIALIZACI MCP23016, zde cekame 100msec. 			
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku	
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;----------------------Nastaveni registru expanderu-----------------------------------
	movlw	IODIR0			;nastaveni in/out									
	call	I2C_odesli		;vyslani dat
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	;zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016											

	movlw	b'00000000'		;data do registru }vsechny piny registru 0 vystup]					
	call	I2C_odesli		;odeslani dat												
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	
;test registroveho paru - zapisuje do IODIR1	
	movlw	b'00000000'		;data do registru (vsechny piny registru 0 vystup]					
	call	I2C_odesli		;odeslani dat												
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	call	I2C_stop		;I2C_STOP
;---nastaveni ukonceno----------------	
blik
;----------pripraveni zapisu do prvniho obvodu------
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;------------adresa registru-------------------------		
	movlw	GP0;OLAT0		;budeme posilat data do vystupniho registru - lhostejno zda primo na port (GPxx) nebo dp registru (OLATxx)
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	
	movlw	b'11111111'		;budeme posilat data 
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016

;test registroveho paru - zapisuje do GP1
	movlw	b'11111111'		;budeme posilat data 
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	call	I2C_stop		;I2C_STOP
	call	CEK40
	call	CEK1s
	
	
;----------pripraveni zapisu do prvniho obvodu------
	call	I2C_start		;I2C_START	
	call	CEK40			;40 usec.									
	movlw	one_write		;adresa - prvni obvod, a budeme zapisovat
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;------------adresa registru-------------------------		
	movlw	GP0;OLAT0			;budeme posilat data do vystupniho registru
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	
	movlw	b'00000000'		;budeme posilat data 
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;test registroveho paru - zapisuje do GP1
	movlw	b'00000000'		;budeme posilat data 
	call	I2C_odesli		;vyslani byte na adresu uvedenou v predeslem radku
	call	I2C_cekani		;cekej na ukonceni
	call	I2C_prijmi_ack	; zkontroluj, zda prislo potvrzeni o prijmu ACK
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
;------
	call	I2C_stop		;I2C_STOP
	call	CEK40			;40 usec. - pauza predepsanych min. 12 usec pro MCP23016
	call	CEK1s
	goto	blik
;********************************KONEC******************************************





;-----------------------------------------------------------------------------------
; I2C podprogramy seriove komunikace
;-----------------------------------------------------------------------------------
;-----------------------------------------------  start bit

I2C_start
	BSF		STATUS,RP0		; banka 1
	BSF		SSPCON2,SEN		; odesli start bit
	BCF		STATUS,RP0		; banka 0
	CALL	I2C_cekani
	RETURN

;-----------------------------------------------  opakovan start bit

I2C_restart
	BSF		STATUS,RP0		; banka 1
	BSF		SSPCON2,RSEN	; odesli opakovany start bit
	BCF		STATUS,RP0		; banka 0
	CALL	I2C_cekani
	RETURN

;-----------------------------------------------  stop bit

I2C_stop
	BSF		STATUS,RP0		; banka 1
	BSF		SSPCON2,PEN		; odesli stop bit
	BCF		STATUS,RP0		; banka 0
	CALL		I2C_cekani
	RETURN

;-----------------------------------------------  odeslany byte

I2C_odesli
	MOVWF		SSPBUF			; odesli byte z pracovniho registru W do eeprom
	RETLW		0

;-----------------------------------------------  prijmuti byte

I2C_prijmi
	BSF		STATUS,RP0		; banka 1
	BSF		SSPCON2,RCEN	; nastav rezim prijmu a prijmi data (1 byte) do SSPBUF
	BCF		STATUS,RP0		; banka 0
	CALL		I2C_cekani		; cekej na dokonceni prijmu
	BSF		STATUS,RP0		; banka 1
	BCF		SSPCON2,RCEN	; nastav zpet rezim odesilani
	BCF		STATUS,RP0		; banka 0
	RETURN

;-----------------------------------------------  prijmuti ack

I2C_prijmi_ack
	BSF		STATUS,RP0		; banka 1
	BTFSC	SSPCON2,ACKSTAT		; zkontroluj zda bylo prijato potvrzeni ACK
	goto	chyba
	BSF		flags,I2C_chyba	; pokud ne, tak nastav bit chyba,0
	BCF		STATUS,RP0		; banka 0
	RETURN

;-----------------------------------------------  odeslani ack

I2C_odesli_ack
	BSF		STATUS,RP0		; banka 1
	BSF		SSPCON2,ACKDT	;ACK data
	BSF		SSPCON2,ACKEN	;odesli ACK data 
	BCF		STATUS,RP0		; banka 0
	RETURN

;-----------------------------------------------  cekani na dokonceni operace

I2C_cekani
I2C_c
	BCF		STATUS,RP0		; banka 0
	BTFSS		PIR1,SSPIF	; byla jiz operace dokoncena ?
	GOTO		I2C_c		; pokud ne, tak cekej na jeji dokonceni
	BCF		PIR1,SSPIF		; vynuluj priznak dokonceni
	RETURN
;-----------------------------------------------




chyba
	goto	$



;**************************************************************************
; casy pro frekvenci krystalu 4,00Mhz
; casy jsou spoitan od call CEKxxm do navratu na volani CEKxxm
; celkovy vypocet  = 2+6+(2+(TMP0-1)*3+2)+3)*TMP1-1+2
; zkraceny vypocet = 8+((TMP0-1)*3+7)*TMP1+1
; mala smycka = (TMP2-1)*3+2
;-------------------------------
CEK2s	movlw	.20		; TMP2 = 20  cekej 2 sekundu
	movwf	TMP3
	goto	SMYCKA2
;-------------------------------
CEK1s	movlw	.10		; TMP2 = 10  cekej 1 sekundu
	movwf	TMP3
	goto	SMYCKA2
;-------------------------------
CEK100m	movlw	0CFh		; cas = 100,009 ms
	movwf	TMP0
	movlw	0A0h
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
CEK15m	movlw	0ABh		; cas = 15,002 ms
	movwf	TMP0
	movlw	01Dh
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
CEK4m	movlw	0A5h		; cas = 4,001 ms
	movwf	TMP0
	movlw	008h
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
CEK1m6	movlw	041h		; cas = 1,601 ms
	movwf	TMP0
	movlw	008h
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
CEK100	movlw 	01Dh		; cas = 100 mikrosekund
	movwf	TMP0
	movlw	001h
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
CEK40	movlw	009h		; cas = 40 mikrosekund
	movwf	TMP0
	movlw	001h
	movwf	TMP1
	goto	SMYCKA
;-------------------------------
SMYCKA2	call	CEK100m
	decfsz	TMP3,F		; nejvetsi smycka
	goto	SMYCKA2
	retlw	00h
;-------------------------------
SMYCKA	movf	TMP0,W
	movwf	TMP2
;       ------------------------
SMYCKA1	decfsz	TMP2,F		; mala smycka
	goto	SMYCKA1
;       ------------------------
	decfsz	TMP1,F		; velka smycka
	goto	SMYCKA
;       ------------------------
	retlw	00h
;**************************************************************************
; -------------------------------------------------------------
; SEND CHARACTER IN W VIA RS232 AND WAIT UNTIL FINISHED SENDING 
; -------------------------------------------------------------
;
send    clrwdt
		movwf TXREG             ; send data in W 

TransWt bsf STATUS,RP0		; RAM PAGE 1
WtHere  btfss TXSTA,TRMT        ; (1) transmission is complete if hi
        goto WtHere

        bcf STATUS,RP0          ; RAM PAGE 0
        return
; -------------------------------------------

;**************************************************************************
SET_232	bsf	STATUS,RP0	; nastaven BANKY 1

	movlw	.12		; rychlost 19600b pro krystal 4,00MHz
	movwf	SPBRG
;       ------------------------
	movlw	b'00100110'	; 8bit, vysln povoleno, asynchron mod, vysok rychlost
	movwf	TXSTA		; !!! nastaven vysln !!!
;-------------------------------
	bcf	STATUS,RP0	; nastaven BANKY 0
	movlw	b'10010000'	; povolen sriov port, 8bit, asynchron mod
	movwf	RCSTA		; !!! nastaven pjmu !!!
	return

;**************************************************************************





;*****************************

	end			; konec programu

